(function(){
	// Listen for added img and videos that fail to load, and use online version
	let ol_onlineCache = new Set();
	let ol_element = document.querySelector('tw-story');
	let ol_config = {subtree:true, childList: true, attributes: false, characterData: false};
	let ol_observer = new MutationObserver(
		function(mods, ob) {
			ob.takeRecords();
			
			let _replaceSrc = function(s) {
				s = s.substring(s.lastIndexOf('/img/'))
				return 'https://x-change.life/'+s;
			};
			
			let _replaceSrcJs = function(e, n) {
				let nn = 'on'+n;
				let f = ''+$(e).prop(nn);
				if (f.startsWith('function') && f.indexOf('this.src=')) {
					let body = /function\b[^\{]*\{([\s\S]*)\}/gm.exec(f)[1];
					body = body.replace('\'img/', '\'https://x-change.life/img/');
					$(e).prop(nn, null);
					$(e).on(n, function(){eval(body);});
				}
				
			};
			
			let _replaceImage = function(i) {
				// patch src if not loaded. Also handle onmouseover/out
				i.src = _replaceSrc(i.src);
				if (i.onmouseover) _replaceSrcJs(i, 'mouseover');
				if (i.onmouseout) _replaceSrcJs(i, 'mouseout');
			}
			
			let _handleImage = function(i) {
				if (ol_onlineCache.has(i.src)) {
					_replaceImage(i);
					return;
				}
				
				let loadFunc = ()=>{
					if (!i.complete) {
						window.setTimeout(loadFunc, 5);
						return;
					}
					if (i.naturalHeight === 0) {
						ol_onlineCache.add(i.src);
						_replaceImage(i);
					}
				};
				window.setTimeout(loadFunc,5);
			};
			
			let _handleVideo = function(v) {
				let origSrc = v.src;
				let onlineSrc = _replaceSrc(v.src);
				$(v).attr('src', null);
				$(v).append("<source src=\""+origSrc+"\"/><source src=\""+onlineSrc+"\"/>");
			};
			
			let _handleAudio = function(a) {
				let srcs = $(a).find('source');
				for (src of srcs) {
					if (!src.src.startsWith('https://')) {
						let newSrc = $(src).clone().get()[0];
						let s = src.src;
						s = s.substring(s.lastIndexOf('/aud/'))
						newSrc.src = 'https://x-change.life/'+s;
						$(a).append(newSrc);
					}
				}
			};
			
			let _handleElements = function(selector) {
				let elems = $(selector).not('.online-handled');
				elems.addClass('online-handled');
				elems.each(function(i,e) {
					switch (e.tagName) {
					case 'IMG': _handleImage(e); break;
					case 'VIDEO': _handleVideo(e); break;
					case 'AUDIO': _handleAudio(e); break;
					}
				});
			
			};
			
			ob.disconnect();
			_handleElements('img');
			_handleElements('video');
			_handleElements('audio');
			ol_observer.observe(ol_element, ol_config);
		}
	);

	ol_observer.observe(ol_element, ol_config);
})();
